diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mpi/examples/third-distributed.cc ns-3.39/src/mpi/examples/third-distributed.cc
--- ns-3.38/src/mpi/examples/third-distributed.cc	2023-03-16 20:54:23.796869000 -0700
+++ ns-3.39/src/mpi/examples/third-distributed.cc	2023-07-05 14:23:48.049428200 -0700
@@ -264,7 +264,7 @@
 
     Simulator::Stop(Seconds(10.0));
 
-    if (tracing == true)
+    if (tracing)
     {
         // Depending on the system Id (rank), the pcap information
         // traced will be different.  For example, the ethernet pcap
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mpi/model/distributed-simulator-impl.cc ns-3.39/src/mpi/model/distributed-simulator-impl.cc
--- ns-3.38/src/mpi/model/distributed-simulator-impl.cc	2023-03-16 20:54:23.796869000 -0700
+++ ns-3.39/src/mpi/model/distributed-simulator-impl.cc	2023-07-05 14:23:48.049428200 -0700
@@ -609,16 +609,9 @@
         }
         return true;
     }
-    if (id.PeekEventImpl() == nullptr || id.GetTs() < m_currentTs ||
-        (id.GetTs() == m_currentTs && id.GetUid() <= m_currentUid) ||
-        id.PeekEventImpl()->IsCancelled())
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
+    return id.PeekEventImpl() == nullptr || id.GetTs() < m_currentTs ||
+           (id.GetTs() == m_currentTs && id.GetUid() <= m_currentUid) ||
+           id.PeekEventImpl()->IsCancelled();
 }
 
 Time
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mpi/model/mpi-receiver.h ns-3.39/src/mpi/model/mpi-receiver.h
--- ns-3.38/src/mpi/model/mpi-receiver.h	2023-03-16 20:54:23.796869000 -0700
+++ ns-3.39/src/mpi/model/mpi-receiver.h	2023-07-05 14:23:48.049428200 -0700
@@ -18,7 +18,7 @@
 /**
  * \file
  * \ingroup mpi
- * ns3::MpiReciver declaration,
+ * ns3::MpiReceiver declaration,
  * provides an interface to aggregate to MPI-compatible NetDevices.
  */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mpi/model/null-message-simulator-impl.cc ns-3.39/src/mpi/model/null-message-simulator-impl.cc
--- ns-3.38/src/mpi/model/null-message-simulator-impl.cc	2023-03-16 20:54:23.796869000 -0700
+++ ns-3.39/src/mpi/model/null-message-simulator-impl.cc	2023-07-05 14:23:48.049428200 -0700
@@ -532,16 +532,9 @@
         }
         return true;
     }
-    if (id.PeekEventImpl() == nullptr || id.GetTs() < m_currentTs ||
-        (id.GetTs() == m_currentTs && id.GetUid() <= m_currentUid) ||
-        id.PeekEventImpl()->IsCancelled())
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
+    return id.PeekEventImpl() == nullptr || id.GetTs() < m_currentTs ||
+           (id.GetTs() == m_currentTs && id.GetUid() <= m_currentUid) ||
+           id.PeekEventImpl()->IsCancelled();
 }
 
 Time
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mpi/model/null-message-simulator-impl.h ns-3.39/src/mpi/model/null-message-simulator-impl.h
--- ns-3.38/src/mpi/model/null-message-simulator-impl.h	2023-03-16 20:54:23.796869000 -0700
+++ ns-3.39/src/mpi/model/null-message-simulator-impl.h	2023-07-05 14:23:48.049428200 -0700
@@ -148,14 +148,14 @@
      * \param bundle Bundle to reschedule Null Message event for
      *
      * Reschedule Null Message event for the specified
-     * RemoteChannelBundel.  Existing event will be canceled.
+     * RemoteChannelBundle.  Existing event will be canceled.
      */
     void RescheduleNullMessageEvent(Ptr<RemoteChannelBundle> bundle);
 
     /**
      * \param nodeSysId SystemID to reschedule null event for
      *
-     * Reschedule Null Message event for the RemoteChannelBundel to the
+     * Reschedule Null Message event for the RemoteChannelBundle to the
      * task nodeSysId.  Existing event will be canceled.
      */
     void RescheduleNullMessageEvent(uint32_t nodeSysId);
@@ -165,7 +165,7 @@
      *
      * \return Guarantee time
      *
-     * Calculate the guarantee time for incoming RemoteChannelBundel
+     * Calculate the guarantee time for incoming RemoteChannelBundle
      * from task nodeSysId.  No message should arrive from task
      * nodeSysId with a receive time less than the guarantee time.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/netanim/CMakeLists.txt ns-3.39/src/netanim/CMakeLists.txt
--- ns-3.38/src/netanim/CMakeLists.txt	2023-03-16 20:54:23.796869000 -0700
+++ ns-3.39/src/netanim/CMakeLists.txt	2023-07-05 14:23:48.049428200 -0700
@@ -12,7 +12,6 @@
     ${libuan}
     ${libenergy}
     ${liblr-wpan}
-    ${libwave}
     ${libpoint-to-point-layout}
   TEST_SOURCES test/netanim-test.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/netanim/model/animation-interface.cc ns-3.39/src/netanim/model/animation-interface.cc
--- ns-3.38/src/netanim/model/animation-interface.cc	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/netanim/model/animation-interface.cc	2023-07-05 14:23:48.057428100 -0700
@@ -35,7 +35,6 @@
 #ifdef __WIN32__
 #include "ns3/bs-net-device.h"
 #include "ns3/csma-net-device.h"
-#include "ns3/wave-net-device.h"
 #endif
 #include "animation-interface.h"
 
@@ -108,7 +107,7 @@
      * The .dll.a/.lib however, only gets linked if we instantiate at
      * least one symbol exported by the .dll.
      *
-     * To ensure TypeIds from the Csma, Uan, Wave, Wifi and Wimax
+     * To ensure TypeIds from the Csma, Uan, Wifi and Wimax
      * modules are registered during runtime, we need to instantiate
      * at least one symbol exported by each of these module libraries.
      */
@@ -116,7 +115,6 @@
     static CsmaNetDevice c;
     static WifiNetDevice w;
     static UanNetDevice u;
-    static WaveNetDevice wv;
 #endif
 }
 
@@ -471,16 +469,8 @@
 AnimationInterface::NodeHasMoved(Ptr<Node> n, Vector newLocation)
 {
     Vector oldLocation = GetPosition(n);
-    bool moved = true;
-    if ((ceil(oldLocation.x) == ceil(newLocation.x)) &&
-        (ceil(oldLocation.y) == ceil(newLocation.y)))
-    {
-        moved = false;
-    }
-    else
-    {
-        moved = true;
-    }
+    bool moved = !((ceil(oldLocation.x) == ceil(newLocation.x)) &&
+                   (ceil(oldLocation.y) == ceil(newLocation.y)));
     return moved;
 }
 
@@ -503,7 +493,6 @@
         PurgePendingPackets(AnimationInterface::LTE);
         PurgePendingPackets(AnimationInterface::CSMA);
         PurgePendingPackets(AnimationInterface::LRWPAN);
-        PurgePendingPackets(AnimationInterface::WAVE);
         Simulator::Schedule(m_mobilityPollInterval, &AnimationInterface::MobilityAutoCheck, this);
     }
 }
@@ -1093,50 +1082,6 @@
 }
 
 void
-AnimationInterface::WavePhyTxBeginTrace(std::string context, Ptr<const Packet> p)
-{
-    NS_LOG_FUNCTION(this);
-    return GenericWirelessTxTrace(context, p, AnimationInterface::WAVE);
-}
-
-void
-AnimationInterface::WavePhyRxBeginTrace(std::string context, Ptr<const Packet> p)
-{
-    NS_LOG_FUNCTION(this);
-    CHECK_STARTED_INTIMEWINDOW_TRACKPACKETS;
-    Ptr<NetDevice> ndev = GetNetDeviceFromContext(context);
-    NS_ASSERT(ndev);
-    UpdatePosition(ndev);
-    uint64_t animUid = GetAnimUidFromPacket(p);
-    NS_LOG_INFO("Wave RxBeginTrace for packet:" << animUid);
-    if (!IsPacketPending(animUid, AnimationInterface::WAVE))
-    {
-        NS_ASSERT_MSG(false, "WavePhyRxBeginTrace: unknown Uid");
-        std::ostringstream oss;
-        WifiMacHeader hdr;
-        if (!p->PeekHeader(hdr))
-        {
-            NS_LOG_WARN("WaveMacHeader not present");
-            return;
-        }
-        oss << hdr.GetAddr2();
-        if (m_macToNodeIdMap.find(oss.str()) == m_macToNodeIdMap.end())
-        {
-            NS_LOG_WARN("Transmitter Mac address " << oss.str() << " never seen before. Skipping");
-            return;
-        }
-        Ptr<Node> txNode = NodeList::GetNode(m_macToNodeIdMap[oss.str()]);
-        UpdatePosition(txNode);
-        AnimPacketInfo pktInfo(nullptr, Simulator::Now(), m_macToNodeIdMap[oss.str()]);
-        AddPendingPacket(AnimationInterface::WAVE, animUid, pktInfo);
-        NS_LOG_WARN("WavePhyRxBegin: unknown Uid, but we are adding a wave packet");
-    }
-    /// \todo NS_ASSERT (WavePacketIsPending (animUid) == true);
-    m_pendingWavePackets[animUid].ProcessRxBegin(ndev, Simulator::Now().GetSeconds());
-    OutputWirelessPacketRxInfo(p, m_pendingWavePackets[animUid], animUid);
-}
-
-void
 AnimationInterface::WimaxTxTrace(std::string context, Ptr<const Packet> p, const Mac48Address& m)
 {
     NS_LOG_FUNCTION(this);
@@ -1427,10 +1372,6 @@
         pendingPackets = &m_pendingLrWpanPackets;
         break;
     }
-    case AnimationInterface::WAVE: {
-        pendingPackets = &m_pendingWavePackets;
-        break;
-    }
     }
     return pendingPackets;
 }
@@ -1465,10 +1406,6 @@
         result = "LRWPAN";
         break;
     }
-    case AnimationInterface::WAVE: {
-        result = "WAVE";
-        break;
-    }
     }
     return result;
 }
@@ -1783,14 +1720,6 @@
                             MakeCallback(&AnimationInterface::LrWpanMacRxTrace, this));
     Config::ConnectFailSafe("/NodeList/*/DeviceList/*/$ns3::LrWpanNetDevice/Mac/MacRxDrop",
                             MakeCallback(&AnimationInterface::LrWpanMacRxDropTrace, this));
-
-    // Wave
-    Config::ConnectFailSafe(
-        "/NodeList/*/DeviceList/*/$ns3::WaveNetDevice/PhyEntities/*/$ns3::WifiPhy/PhyTxBegin",
-        MakeCallback(&AnimationInterface::WavePhyTxBeginTrace, this));
-    Config::ConnectFailSafe(
-        "/NodeList/*/DeviceList/*/$ns3::WaveNetDevice/PhyEntities/*/$ns3::WifiPhy/PhyRxBegin",
-        MakeCallback(&AnimationInterface::WavePhyRxBeginTrace, this));
 }
 
 Vector
@@ -2015,7 +1944,7 @@
             }
             NS_LOG_DEBUG("Got ChannelType" << channelType);
 
-            if (!ch || (channelType != std::string("ns3::PointToPointChannel")))
+            if (!ch || (channelType != "ns3::PointToPointChannel"))
             {
                 NS_LOG_DEBUG("No channel can't be a p2p device");
                 /*
@@ -2050,7 +1979,7 @@
                 continue;
             }
 
-            else if (channelType == std::string("ns3::PointToPointChannel"))
+            else if (channelType == "ns3::PointToPointChannel")
             { // Since these are duplex links, we only need to dump
                 // if srcid < dstid
                 std::size_t nChDev = ch->GetNDevices();
@@ -2153,14 +2082,7 @@
 bool
 AnimationInterface::IsInTimeWindow()
 {
-    if ((Simulator::Now() >= m_startTime) && (Simulator::Now() <= m_stopTime))
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
+    return Simulator::Now() >= m_startTime && Simulator::Now() <= m_stopTime;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/netanim/model/animation-interface.h ns-3.39/src/netanim/model/animation-interface.h
--- ns-3.38/src/netanim/model/animation-interface.h	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/netanim/model/animation-interface.h	2023-07-05 14:23:48.057428100 -0700
@@ -50,7 +50,7 @@
 
 #define MAX_PKTS_PER_TRACE_FILE 100000
 #define PURGE_INTERVAL 5
-#define NETANIM_VERSION "netanim-3.108"
+#define NETANIM_VERSION "netanim-3.109"
 #define CHECK_STARTED_INTIMEWINDOW                                                                 \
     {                                                                                              \
         if (!m_started || !IsInTimeWindow())                                                       \
@@ -544,8 +544,7 @@
         WIFI,
         WIMAX,
         CSMA,
-        LRWPAN,
-        WAVE
+        LRWPAN
     };
 
     /// NodeSize structure
@@ -669,7 +668,6 @@
     AnimUidPacketInfoMap m_pendingLtePackets;    ///< pending LTE packets
     AnimUidPacketInfoMap m_pendingCsmaPackets;   ///< pending CSMA packets
     AnimUidPacketInfoMap m_pendingUanPackets;    ///< pending UAN packets
-    AnimUidPacketInfoMap m_pendingWavePackets;   ///< pending WAVE packets
 
     std::map<uint32_t, Vector> m_nodeLocation;         ///< node location
     std::map<std::string, uint32_t> m_macToNodeIdMap;  ///< MAC to node ID map
@@ -1078,19 +1076,6 @@
                              Ptr<const Packet> p,
                              RxPowerWattPerChannelBand rxPowersW);
     /**
-     * WAVE Phy transmit begin trace function
-     * \param context the context
-     * \param p the packet
-     */
-    void WavePhyTxBeginTrace(std::string context, Ptr<const Packet> p);
-    /**
-     * WAVE Phy receive begin trace function
-     *
-     * \param context the context
-     * \param p the packet
-     */
-    void WavePhyRxBeginTrace(std::string context, Ptr<const Packet> p);
-    /**
      * LR-WPAN Phy receive begin trace function
      *
      * \param context the context
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/netanim/test/examples-to-run.py ns-3.39/src/netanim/test/examples-to-run.py
--- ns-3.38/src/netanim/test/examples-to-run.py	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/netanim/test/examples-to-run.py	2023-07-05 14:23:48.057428100 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/examples/CMakeLists.txt ns-3.39/src/network/examples/CMakeLists.txt
--- ns-3.38/src/network/examples/CMakeLists.txt	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/network/examples/CMakeLists.txt	2023-07-05 14:23:48.057428100 -0700
@@ -3,7 +3,7 @@
     main-packet-header
     main-packet-tag
     packet-socket-apps
-    lollipop-comparisions
+    lollipop-comparisons
 )
 
 foreach(
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/examples/lollipop-comparisons.cc ns-3.39/src/network/examples/lollipop-comparisons.cc
--- ns-3.38/src/network/examples/lollipop-comparisons.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/network/examples/lollipop-comparisons.cc	2023-07-05 14:23:48.057428100 -0700
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2020 Universita' di Firenze, Italy
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+
+#include "ns3/lollipop-counter.h"
+
+using namespace ns3;
+
+int
+main(int argc, char* argv[])
+{
+    LollipopCounter8 counterA;
+    LollipopCounter8 counterB;
+
+    //  counterA.SetSequenceWindowSize (5);
+    //  counterB.SetSequenceWindowSize (5);
+
+    for (uint8_t i = 0; i < std::numeric_limits<uint8_t>::max(); i++)
+    {
+        std::cout << +i << " -- ";
+        for (uint8_t j = 0; j < std::numeric_limits<uint8_t>::max(); j++)
+        {
+            counterA = i;
+            counterB = j;
+            if (counterA < counterB)
+            {
+                std::cout << "<";
+            }
+            else if (counterA == counterB)
+            {
+                std::cout << "=";
+            }
+            else if (counterA > counterB)
+            {
+                std::cout << ">";
+            }
+            else
+            {
+                std::cout << ".";
+            }
+        }
+        std::cout << std::endl;
+    }
+
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/address.h ns-3.39/src/network/model/address.h
--- ns-3.38/src/network/model/address.h	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/network/model/address.h	2023-07-05 14:23:48.057428100 -0700
@@ -103,10 +103,7 @@
      * The maximum size of a byte buffer which
      * can be stored in an Address instance.
      */
-    enum MaxSize_e
-    {
-        MAX_SIZE = 20
-    };
+    static constexpr uint32_t MAX_SIZE{20};
 
     /**
      * Create an invalid address
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/buffer.cc ns-3.39/src/network/model/buffer.cc
--- ns-3.38/src/network/model/buffer.cc	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/network/model/buffer.cc	2023-07-05 14:23:48.061428300 -0700
@@ -81,7 +81,7 @@
 #define UNINITIALIZED ((Buffer::FreeList*)0)
 uint32_t Buffer::g_maxSize = 0;
 Buffer::FreeList* Buffer::g_freeList = nullptr;
-struct Buffer::LocalStaticDestructor Buffer::g_localStaticDestructor;
+Buffer::LocalStaticDestructor Buffer::g_localStaticDestructor;
 
 Buffer::LocalStaticDestructor::~LocalStaticDestructor()
 {
@@ -98,7 +98,7 @@
 }
 
 void
-Buffer::Recycle(struct Buffer::Data* data)
+Buffer::Recycle(Buffer::Data* data)
 {
     NS_LOG_FUNCTION(data);
     NS_ASSERT(data->m_count == 0);
@@ -129,7 +129,7 @@
     {
         while (!g_freeList->empty())
         {
-            struct Buffer::Data* data = g_freeList->back();
+            Buffer::Data* data = g_freeList->back();
             g_freeList->pop_back();
             if (data->m_size >= dataSize)
             {
@@ -139,13 +139,13 @@
             Buffer::Deallocate(data);
         }
     }
-    struct Buffer::Data* data = Buffer::Allocate(dataSize);
+    Buffer::Data* data = Buffer::Allocate(dataSize);
     NS_ASSERT(data->m_count == 1);
     return data;
 }
 #else  /* BUFFER_FREE_LIST */
 void
-Buffer::Recycle(struct Buffer::Data* data)
+Buffer::Recycle(Buffer::Data* data)
 {
     NS_LOG_FUNCTION(data);
     NS_ASSERT(data->m_count == 0);
@@ -160,7 +160,9 @@
 }
 #endif /* BUFFER_FREE_LIST */
 
-struct Buffer::Data*
+constexpr uint32_t ALLOC_OVER_PROVISION = 100; //!< Additional bytes to over-provision.
+
+Buffer::Data*
 Buffer::Allocate(uint32_t reqSize)
 {
     NS_LOG_FUNCTION(reqSize);
@@ -169,16 +171,17 @@
         reqSize = 1;
     }
     NS_ASSERT(reqSize >= 1);
-    uint32_t size = reqSize - 1 + sizeof(struct Buffer::Data);
+    reqSize += ALLOC_OVER_PROVISION;
+    uint32_t size = reqSize - 1 + sizeof(Buffer::Data);
     uint8_t* b = new uint8_t[size];
-    struct Buffer::Data* data = reinterpret_cast<struct Buffer::Data*>(b);
+    Buffer::Data* data = reinterpret_cast<Buffer::Data*>(b);
     data->m_size = reqSize;
     data->m_count = 1;
     return data;
 }
 
 void
-Buffer::Deallocate(struct Buffer::Data* data)
+Buffer::Deallocate(Buffer::Data* data)
 {
     NS_LOG_FUNCTION(data);
     NS_ASSERT(data->m_count == 0);
@@ -201,7 +204,7 @@
 Buffer::Buffer(uint32_t dataSize, bool initialize)
 {
     NS_LOG_FUNCTION(this << dataSize << initialize);
-    if (initialize == true)
+    if (initialize)
     {
         Initialize(dataSize);
     }
@@ -328,7 +331,7 @@
     else
     {
         uint32_t newSize = GetInternalSize() + start;
-        struct Buffer::Data* newData = Buffer::Create(newSize);
+        Buffer::Data* newData = Buffer::Create(newSize);
         memcpy(newData->m_data + start, m_data->m_data + m_start, GetInternalSize());
         m_data->m_count--;
         if (m_data->m_count == 0)
@@ -374,7 +377,7 @@
     else
     {
         uint32_t newSize = GetInternalSize() + end;
-        struct Buffer::Data* newData = Buffer::Create(newSize);
+        Buffer::Data* newData = Buffer::Create(newSize);
         memcpy(newData->m_data, m_data->m_data + m_start, GetInternalSize());
         m_data->m_count--;
         if (m_data->m_count == 0)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/buffer.h ns-3.39/src/network/model/buffer.h
--- ns-3.38/src/network/model/buffer.h	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/network/model/buffer.h	2023-07-05 14:23:48.061428300 -0700
@@ -732,26 +732,26 @@
      * \brief Recycle the buffer memory
      * \param data the buffer data storage
      */
-    static void Recycle(struct Buffer::Data* data);
+    static void Recycle(Buffer::Data* data);
     /**
      * \brief Create a buffer data storage
      * \param size the storage size to create
      * \returns a pointer to the created buffer storage
      */
-    static struct Buffer::Data* Create(uint32_t size);
+    static Buffer::Data* Create(uint32_t size);
     /**
      * \brief Allocate a buffer data storage
      * \param reqSize the storage size to create
      * \returns a pointer to the allocated buffer storage
      */
-    static struct Buffer::Data* Allocate(uint32_t reqSize);
+    static Buffer::Data* Allocate(uint32_t reqSize);
     /**
      * \brief Deallocate the buffer memory
      * \param data the buffer data storage
      */
-    static void Deallocate(struct Buffer::Data* data);
+    static void Deallocate(Buffer::Data* data);
 
-    struct Data* m_data; //!< the buffer data storage
+    Data* m_data; //!< the buffer data storage
 
     /**
      * keep track of the maximum value of m_zeroAreaStart across
@@ -794,7 +794,7 @@
 
 #ifdef BUFFER_FREE_LIST
     /// Container for buffer data
-    typedef std::vector<struct Buffer::Data*> FreeList;
+    typedef std::vector<Buffer::Data*> FreeList;
 
     /// Local static destructor structure
     struct LocalStaticDestructor
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/byte-tag-list.cc ns-3.39/src/network/model/byte-tag-list.cc
--- ns-3.38/src/network/model/byte-tag-list.cc	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/network/model/byte-tag-list.cc	2023-07-05 14:23:48.061428300 -0700
@@ -56,7 +56,7 @@
  *
  * Internal use only.
  */
-static class ByteTagListDataFreeList : public std::vector<struct ByteTagListData*>
+static class ByteTagListDataFreeList : public std::vector<ByteTagListData*>
 {
   public:
     ~ByteTagListDataFreeList();
@@ -88,7 +88,7 @@
     return m_current < m_end;
 }
 
-struct ByteTagList::Iterator::Item
+ByteTagList::Iterator::Item
 ByteTagList::Iterator::Next()
 {
     NS_ASSERT(HasNext());
@@ -213,7 +213,7 @@
     }
     else if (m_data->size < spaceNeeded || (m_data->count != 1 && m_data->dirty != m_used))
     {
-        struct ByteTagListData* newData = Allocate(spaceNeeded);
+        ByteTagListData* newData = Allocate(spaceNeeded);
         std::memcpy(&newData->data, &m_data->data, m_used);
         Deallocate(m_data);
         m_data = newData;
@@ -351,13 +351,13 @@
 
 #ifdef USE_FREE_LIST
 
-struct ByteTagListData*
+ByteTagListData*
 ByteTagList::Allocate(uint32_t size)
 {
     NS_LOG_FUNCTION(this << size);
     while (!g_freeList.empty())
     {
-        struct ByteTagListData* data = g_freeList.back();
+        ByteTagListData* data = g_freeList.back();
         g_freeList.pop_back();
         NS_ASSERT(data != nullptr);
         if (data->size >= size)
@@ -369,8 +369,8 @@
         uint8_t* buffer = (uint8_t*)data;
         delete[] buffer;
     }
-    uint8_t* buffer = new uint8_t[std::max(size, g_maxSize) + sizeof(struct ByteTagListData) - 4];
-    struct ByteTagListData* data = (struct ByteTagListData*)buffer;
+    uint8_t* buffer = new uint8_t[std::max(size, g_maxSize) + sizeof(ByteTagListData) - 4];
+    ByteTagListData* data = (ByteTagListData*)buffer;
     data->count = 1;
     data->size = size;
     data->dirty = 0;
@@ -378,7 +378,7 @@
 }
 
 void
-ByteTagList::Deallocate(struct ByteTagListData* data)
+ByteTagList::Deallocate(ByteTagListData* data)
 {
     NS_LOG_FUNCTION(this << data);
     if (data == nullptr)
@@ -403,12 +403,12 @@
 
 #else /* USE_FREE_LIST */
 
-struct ByteTagListData*
+ByteTagListData*
 ByteTagList::Allocate(uint32_t size)
 {
     NS_LOG_FUNCTION(this << size);
-    uint8_t* buffer = new uint8_t[size + sizeof(struct ByteTagListData) - 4];
-    struct ByteTagListData* data = (struct ByteTagListData*)buffer;
+    uint8_t* buffer = new uint8_t[size + sizeof(ByteTagListData) - 4];
+    ByteTagListData* data = (ByteTagListData*)buffer;
     data->count = 1;
     data->size = size;
     data->dirty = 0;
@@ -416,7 +416,7 @@
 }
 
 void
-ByteTagList::Deallocate(struct ByteTagListData* data)
+ByteTagList::Deallocate(ByteTagListData* data)
 {
     NS_LOG_FUNCTION(this << data);
     if (data == 0)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/byte-tag-list.h ns-3.39/src/network/model/byte-tag-list.h
--- ns-3.38/src/network/model/byte-tag-list.h	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/network/model/byte-tag-list.h	2023-07-05 14:23:48.061428300 -0700
@@ -111,7 +111,7 @@
          *
          * \returns the next Item in the ByteTagList
          */
-        struct ByteTagList::Iterator::Item Next();
+        ByteTagList::Iterator::Item Next();
 
         /**
          * \brief Returns the offset from the start of the virtual byte buffer to the ByteTagList
@@ -275,19 +275,19 @@
      * \param size the memory to allocate
      * \returns the ByteTagListData structure
      */
-    struct ByteTagListData* Allocate(uint32_t size);
+    ByteTagListData* Allocate(uint32_t size);
 
     /**
      * \brief Deallocates a ByteTagListData
      * \param data the ByteTagListData to deallocate
      */
-    void Deallocate(struct ByteTagListData* data);
+    void Deallocate(ByteTagListData* data);
 
-    int32_t m_minStart;             //!< minimal start offset
-    int32_t m_maxEnd;               //!< maximal end offset
-    int32_t m_adjustment;           //!< adjustment to byte tag offsets
-    uint32_t m_used;                //!< the number of used bytes in the buffer
-    struct ByteTagListData* m_data; //!< the ByteTagListData structure
+    int32_t m_minStart;      //!< minimal start offset
+    int32_t m_maxEnd;        //!< maximal end offset
+    int32_t m_adjustment;    //!< adjustment to byte tag offsets
+    uint32_t m_used;         //!< the number of used bytes in the buffer
+    ByteTagListData* m_data; //!< the ByteTagListData structure
 };
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/net-device.h ns-3.39/src/network/model/net-device.h
--- ns-3.38/src/network/model/net-device.h	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/network/model/net-device.h	2023-07-05 14:23:48.061428300 -0700
@@ -348,7 +348,7 @@
                      uint16_t,
                      const Address&,
                      const Address&,
-                     enum PacketType>
+                     PacketType>
         PromiscReceiveCallback;
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/nix-vector.cc ns-3.39/src/network/model/nix-vector.cc
--- ns-3.38/src/network/model/nix-vector.cc	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/network/model/nix-vector.cc	2023-07-05 14:23:48.061428300 -0700
@@ -257,13 +257,13 @@
         m_used = *p++;
 
         // NixVector is packed in 32-bit unsigned ints.
-        uint32_t nixVectorLenth = m_totalBitSize / 32;
-        nixVectorLenth += (m_totalBitSize % 32) ? 1 : 0;
+        uint32_t nixVectorLength = m_totalBitSize / 32;
+        nixVectorLength += (m_totalBitSize % 32) ? 1 : 0;
 
-        NS_ASSERT_MSG(size >= 16 + nixVectorLenth,
-                      "NixVector serialized length should have been " << 16 + nixVectorLenth
+        NS_ASSERT_MSG(size >= 16 + nixVectorLength,
+                      "NixVector serialized length should have been " << 16 + nixVectorLength
                                                                       << " but buffer is shorter");
-        if (size < 16 + nixVectorLenth * 4)
+        if (size < 16 + nixVectorLength * 4)
         {
             // return zero if an entire nix-vector was
             // not deserialized
@@ -273,7 +273,7 @@
         // make sure the nix-vector
         // is empty
         m_nixVector.clear();
-        for (uint32_t j = 0; j < nixVectorLenth; j++)
+        for (uint32_t j = 0; j < nixVectorLength; j++)
         {
             uint32_t nix = *p++;
             m_nixVector.push_back(nix);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/node.cc ns-3.39/src/network/model/node.cc
--- ns-3.38/src/network/model/node.cc	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/network/model/node.cc	2023-07-05 14:23:48.061428300 -0700
@@ -245,7 +245,7 @@
                               bool promiscuous)
 {
     NS_LOG_FUNCTION(this << &handler << protocolType << device << promiscuous);
-    struct Node::ProtocolHandlerEntry entry;
+    Node::ProtocolHandlerEntry entry;
     entry.handler = handler;
     entry.protocol = protocolType;
     entry.device = device;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/node.h ns-3.39/src/network/model/node.h
--- ns-3.38/src/network/model/node.h	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/network/model/node.h	2023-07-05 14:23:48.061428300 -0700
@@ -293,7 +293,7 @@
     };
 
     /// Typedef for protocol handlers container
-    typedef std::vector<struct Node::ProtocolHandlerEntry> ProtocolHandlerList;
+    typedef std::vector<Node::ProtocolHandlerEntry> ProtocolHandlerList;
     /// Typedef for NetDevice addition listeners container
     typedef std::vector<DeviceAdditionListener> DeviceAdditionListenerList;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/network/model/packet.cc ns-3.39/src/network/model/packet.cc
--- ns-3.38/src/network/model/packet.cc	2023-03-16 20:54:23.804869200 -0700
+++ ns-3.39/src/network/model/packet.cc	2023-07-05 14:23:48.061428300 -0700
@@ -89,7 +89,7 @@
 {
 }
 
-PacketTagIterator::PacketTagIterator(const struct PacketTagList::TagData* head)
+PacketTagIterator::PacketTagIterator(const PacketTagList::TagData* head)
     : m_current(head)
 {
 }
@@ -104,12 +104,12 @@
 PacketTagIterator::Next()
 {
     NS_ASSERT(HasNext());
-    const struct PacketTagList::TagData* prev = m_current;
+    const PacketTagList::TagData* prev = m_current;
     m_current = m_current->next;
     return PacketTagIterator::Item(prev);
 }
 
-PacketTagIterator::Item::Item(const struct PacketTagList::TagData* data)
+PacketTagIterator::Item::Item(const PacketTagList::TagData* data)
     : m_data(data)
 {
 }
@@ -471,8 +471,8 @@
                 os << item.tid.GetName();
                 break;
             }
-            os << " Fragment [" << item.currentTrimedFromStart << ":"
-               << (item.currentTrimedFromStart + item.currentSize) << "]";
+            os << " Fragment [" << item.currentTrimmedFromStart << ":"
+               << (item.currentTrimmedFromStart + item.currentSize) << "]";
         }
         else
         {
@@ -540,8 +540,8 @@
               os << item.tid.GetName ();
               break;
             }
-          os << " Fragment [" << item.currentTrimedFromStart<<":"
-             << (item.currentTrimedFromStart + item.currentSize) << "]";
+          os << " Fragment [" << item.currentTrimmedFromStart<<":"
+             << (item.currentTrimmedFromStart + item.currentSize) << "]";
         }
       else
         {
